// TsPacketParser.h: CTsPacketParser NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#pragma once


#include "MediaDecoder.h"
#include "TsStream.h"
#include "EpgDataCapDllUtil.h"


/////////////////////////////////////////////////////////////////////////////
// TSpPbgofR[_(oCif[^TSpPbg𒊏o)
/////////////////////////////////////////////////////////////////////////////
// Input	#0	: CMediaData	TSpPbg܂ރoCif[^
// Output	#0	: CTsPacket		TSpPbg
/////////////////////////////////////////////////////////////////////////////

typedef struct _ST_EPG_DATA{
	char		m_szEventName[120];
	char		m_szEventText[240];
	char		m_szEventExtText[512];
	DWORD		m_dwServiceID;
	DWORD		m_dwEventID;
	SYSTEMTIME	m_tmStart;
	SYSTEMTIME	m_tmEnd;
}ST_EPG_DATA,*LP_ST_EPG_DATA;

class CTsPacketParser : public CMediaDecoder  
{
public:
	enum EVENTID
	{
		EID_EPG_PF_UPDATE,	// T[rXXgXV
	};

	CTsPacketParser(IEventHandler *pEventHandler = NULL);
	virtual ~CTsPacketParser();

// IMediaDecoder
	virtual void Reset(void);
	virtual const bool InputMedia(CMediaData *pMediaData, const DWORD dwInputIndex = 0UL);

// CTsPacketParser
	void SetOutputNullPacket(const bool bEnable = true);

	const DWORD GetInputPacketCount(void) const;
	const DWORD GetOutputPacketCount(void) const;
	const DWORD GetErrorPacketCount(void) const;

	DWORD GetProgramInfo(WORD wSID, BOOL bNext,ST_EPG_DATA *pData);
	void PutEpgSID(WORD wSID);

private:
	void inline SyncPacket(const BYTE *pData, const DWORD dwSize);
	void inline ParsePacket(void);

	CTsPacket m_TsPacket;
	CEpgDataCapDllUtil m_cEpgCap;
	WORD	m_wEpgSID;
	DWORD	m_dwCurrentEventID;

	bool m_bOutputNullPacket;

	DWORD m_dwInputPacketCount;
	DWORD m_dwOutputPacketCount;
	DWORD m_dwErrorPacketCount;
	BYTE m_abyContCounter[0x1FFF];
};
