#include <windows.h>
#include <stdio.h>
#include "CDBTVInfo.h"

#define INPUT_DB_FILE_MAP_NAME "FMAP_LVTV_CHDB"
#define INPUT_DB_FILE_NAME "LVTV_CHINFO"
#define INPUT_DB_MUTEX_NAME "Mutex_LVTVCHINFO"
#define DATA_MAX_NUM 120

#define HEADER_STRING "LVTVCHINFO"

#ifndef FILEEXIST
#define FILEEXIST(s) ((::GetFileAttributes(s) != 0xFFFFFFFF) ? TRUE : FALSE)
#endif

//PDigiUtil.cppŒ`Ă֐
extern BOOL GetAppCfgDir(BOOL IsCommon, char *pszPath,int cbPath);

CDBTVInfo::CDBTVInfo(){
	m_pstTVInfo = NULL;
	m_pstTVHeader = NULL;
}

CDBTVInfo::~CDBTVInfo(){
	UnInit();
}

//
BOOL CDBTVInfo::Init(void){
	return Init(0);
}

BOOL CDBTVInfo::Init(DWORD dwSpace){

	BOOL lRet;

	char szDBPath[MAX_PATH];
	char szDBfile[MAX_PATH];
	char szFMapName[MAX_PATH];

	int nFileMapSize;
	BOOL IsFirstInit = FALSE;

	//I[vς݂mF
	if(m_pstTVInfo != NULL)return TRUE;

	//t@C쐬
	GetAppCfgDir(TRUE,szDBPath,MAX_PATH);
	_snprintf(szDBfile,MAX_PATH,"%s%s_%d.dat",szDBPath,INPUT_DB_FILE_NAME,dwSpace);

	//t@C}bv
	_snprintf(szFMapName,MAX_PATH,"%s_%d",INPUT_DB_FILE_MAP_NAME,dwSpace);
	lRet = OpenFileMap(szFMapName);

	if(lRet == FALSE){
		//t@C}bv
		nFileMapSize = sizeof(ST_TV_INFO_HEADER) + sizeof(ST_TV_INFOMATION) * DATA_MAX_NUM;

		if(FILEEXIST(szDBfile) == FALSE)IsFirstInit=TRUE;

		lRet = Initialize(szDBfile,szFMapName,nFileMapSize);

		if(lRet == FALSE)return FALSE;

		//wb_ݒ肷(ݒ)
		if(IsFirstInit == TRUE){
			m_pstTVHeader = (ST_TV_INFO_HEADER *)GetFileMap();

			strcpy(m_pstTVHeader->szHeader,HEADER_STRING);
			m_pstTVHeader->dwVer = MAKELONG(0x00,0x01);
			m_pstTVHeader->lCurrentChannel = 13;
		}
	}

	//t@C}bvfoCX}bvɊ蓖Ă
	m_pstTVHeader = (ST_TV_INFO_HEADER *)GetFileMap();
	m_pstTVInfo = (ST_TV_INFOMATION *)((DWORD)m_pstTVHeader + sizeof(ST_TV_INFO_HEADER));

	return TRUE;
}

//
BOOL CDBTVInfo::UnInit(void){
	if(m_pstTVInfo != NULL){
		ReleaseData();
		m_pstTVInfo = NULL;
		m_pstTVHeader = NULL;
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//̒ǉ
BOOL CDBTVInfo::Add(void *pInfo, int cbInfo){
	
	BOOL lFuncRet = FALSE;
	ST_TV_INFOMATION *pDatInfo;

	if(m_pstTVInfo == NULL)return FALSE;
	if(cbInfo != sizeof(ST_TV_INFOMATION)) return FALSE;

	//̃AvmF
	if(SetMutex(INPUT_DB_MUTEX_NAME) == FALSE) return FALSE;

	if(m_pstTVHeader->nDatCount < DATA_MAX_NUM-1){
		
		//IDݒ肷
		++m_pstTVHeader->dwLastID;
		pDatInfo = (ST_TV_INFOMATION *)pInfo;
		pDatInfo->dwID = m_pstTVHeader->dwLastID;

		//f[^Rs[
		CopyMemory(&m_pstTVInfo[m_pstTVHeader->nDatCount],pInfo,cbInfo);
		++m_pstTVHeader->nDatCount;

		lFuncRet = TRUE;
	
	}

	//~[ebNX
	ReleaseMutex();
	
	return lFuncRet;
}

//////////////////////////////////////////////////////////////////////////////
//̕ύX
BOOL CDBTVInfo::SetInfoIdx(int nIdx,void *pInfo, int cbInfo){

	if(m_pstTVInfo == NULL)return FALSE;
	if(nIdx < 0 || nIdx >= m_pstTVHeader->nDatCount)return FALSE;
	if(cbInfo != sizeof(ST_TV_INFOMATION)) return FALSE;

	//̃AvmF
	if(SetMutex(INPUT_DB_MUTEX_NAME) == FALSE) return FALSE;

	CopyMemory(&m_pstTVInfo[nIdx],pInfo,cbInfo);
	
	//~[ebNX
	ReleaseMutex();
	
	return TRUE;
}

BOOL CDBTVInfo::SetInfoID(DWORD dwID,void *pInfo, int cbInfo){
	return FALSE;
}

//////////////////////////////////////////////////////////////////////////////
//̎擾
BOOL CDBTVInfo::GetInfoIdx(int nIdx,void *pInfo, int cbInfo){
	if(m_pstTVInfo == NULL)return FALSE;
	if(nIdx < 0 || nIdx >= m_pstTVHeader->nDatCount)return FALSE;
	if(cbInfo != sizeof(ST_TV_INFOMATION)) return FALSE;
	
	//̃AvmF
	if(SetMutex(INPUT_DB_MUTEX_NAME) == FALSE) return FALSE;
	
	CopyMemory(pInfo,&m_pstTVInfo[nIdx],sizeof(ST_TV_INFOMATION));

	//~[ebNX
	ReleaseMutex();

	return TRUE;
}

BOOL CDBTVInfo::GetInfoID(DWORD dwID,void *pInfo, int cbInfo){
	return FALSE;
}

//폜
BOOL CDBTVInfo::DeleteIdx(int nIdx){
	if(m_pstTVInfo == NULL)return FALSE;
	if(nIdx < 0 || nIdx >= m_pstTVHeader->nDatCount)return FALSE;

	//̃AvmF
	if(SetMutex(INPUT_DB_MUTEX_NAME) == FALSE) return FALSE;

	int nCopySize;
	nCopySize = sizeof(ST_TV_INFOMATION) * (m_pstTVHeader->nDatCount - nIdx);

	CopyMemory(&m_pstTVInfo[nIdx],&m_pstTVInfo[nIdx+1],nCopySize);

	--m_pstTVHeader->nDatCount;

	//~[ebNX
	ReleaseMutex();

	return TRUE;
}

BOOL CDBTVInfo::DeleteID(DWORD dwID){
	return FALSE;
}

//̎擾(wb_)
BOOL CDBTVInfo::GetDBVer(DWORD *pdwVer){
	if(m_pstTVHeader == NULL)return FALSE;

	//̃AvmF
	if(SetMutex(INPUT_DB_MUTEX_NAME) == FALSE) return FALSE;
	
	*pdwVer = m_pstTVHeader->dwVer;
	
	//~[ebNX
	ReleaseMutex();

	return TRUE;
}

BOOL CDBTVInfo::GetCurrentChannel(long *plCh){
	if(m_pstTVHeader == NULL)return FALSE;
	
	//̃AvmF
	if(SetMutex(INPUT_DB_MUTEX_NAME) == FALSE) return FALSE;

	*plCh = m_pstTVHeader->lCurrentChannel;
	
	//~[ebNX
	ReleaseMutex();
	
	return TRUE;
}

BOOL CDBTVInfo::SetCurrentChannel(long lCh){
	if(m_pstTVHeader == NULL)return FALSE;
	
	//̃AvmF
	if(SetMutex(INPUT_DB_MUTEX_NAME) == FALSE) return FALSE;

	m_pstTVHeader->lCurrentChannel = lCh;
	
	//~[ebNX
	ReleaseMutex();
	
	return TRUE;
}

//S̏
BOOL CDBTVInfo::ClearAllData(void){
	if(m_pstTVInfo == NULL)return FALSE;
	
	ZeroMemory(m_pstTVInfo,sizeof(ST_TV_INFOMATION) * DATA_MAX_NUM);
	m_pstTVHeader->nDatCount = 0;

	return TRUE;
}

//擾
BOOL CDBTVInfo::GetCount(int *pnCount){
	if(m_pstTVHeader == NULL)return FALSE;

	//̃AvmF
	if(SetMutex(INPUT_DB_MUTEX_NAME) == FALSE) return FALSE;

	*pnCount = m_pstTVHeader->nDatCount;

	//~[ebNX
	ReleaseMutex();

	return TRUE;
}

int CDBTVInfo::SortCmp( const void *arg1, const void *arg2 ){
	ST_TV_INFOMATION *pChInfo1;
	ST_TV_INFOMATION *pChInfo2;

	int nRet = 0;

	pChInfo1 = (ST_TV_INFOMATION *)arg1;
	pChInfo2 = (ST_TV_INFOMATION *)arg2;

	if(pChInfo1->nRmCtrlKeyID != pChInfo2->nRmCtrlKeyID)
		nRet = pChInfo1->nLogicalCh - pChInfo2->nLogicalCh;
	else{
		if(pChInfo1->nNIT1 == pChInfo2->nNIT1)
			nRet = pChInfo1->lSvrIdx - pChInfo2->lSvrIdx;
		else
			nRet = pChInfo1->lChIdx - pChInfo2->lChIdx;
	}

	return nRet;
}

//f[^̃\[g
BOOL CDBTVInfo::Sort(void){
	int nCount;

	if(GetCount(&nCount) == FALSE)return FALSE;

	//̃AvmF
	if(SetMutex(INPUT_DB_MUTEX_NAME) == FALSE) return FALSE;

	qsort( (void *)m_pstTVInfo, (size_t)nCount, sizeof( ST_TV_INFOMATION ), SortCmp );

	//~[ebNX
	ReleaseMutex();

	return TRUE;
}
