#ifndef __CRETICAL_SECTION_
#define __CRETICAL_SECTION_

//NeBJZNVbp[NX
class CYCritSec {

    CYCritSec(const CYCritSec &refCritSec);
    CYCritSec &operator=(const CYCritSec &refCritSec);

    CRITICAL_SECTION m_CritSec;

public:
    CYCritSec() {
        InitializeCriticalSection(&m_CritSec);
    };

    ~CYCritSec() {
        DeleteCriticalSection(&m_CritSec);
    };

    void Lock() {
        EnterCriticalSection(&m_CritSec);
    };

    void Unlock() {
        LeaveCriticalSection(&m_CritSec);
    };
};

//NeBJZNVEbN/NX
class CYAutoLock {

    CYAutoLock(const CYAutoLock &refAutoLock);
    CYAutoLock &operator=(const CYAutoLock &refAutoLock);

protected:
    CYCritSec * m_pLock;

public:
    CYAutoLock(CYCritSec * plock)
    {
        m_pLock = plock;
        m_pLock->Lock();
    };

    ~CYAutoLock() {
        m_pLock->Unlock();
    };
};

#endif
