#include <windows.h>
#include <stdio.h>

#include "CMsgWindow.h"
#include "..\Util\StrUtil.h"

#define OVERLAY_COLOR RGB(16,0,16) /*I[o[CɎgpF*/

#define TIMER_ID_STRING_OFF 1	/*Iɏ^C}*/

CMsgWindow::CMsgWindow(){
	m_hWnd = NULL;
	m_hInst = NULL;
	m_hFont = NULL;
	m_hWOwner = NULL;
	m_hBrush = NULL;

	m_str[0] = '\0';
	m_x=0;
	m_y=0;

	m_flagShow = FALSE;

	m_BackCol = OVERLAY_COLOR;		//wiF
	m_StrCol = RGB(0,255,0);		//̐F
	m_StrColA = RGB(0,128,0);

}

CMsgWindow::~CMsgWindow(){
	if(m_hFont != NULL)DeleteObject(m_hFont);
	if(m_hBrush != NULL)DeleteObject(m_hBrush);
}

HWND CMsgWindow::CreateWnd(DWORD dwExStyle,DWORD dwStyle,
					int x,int y,int nWidth,int nHeight,
					HWND hwndParent,
					HMENU hmenu,
					HINSTANCE hinst){
					
	if(m_hWnd != NULL)return m_hWnd;

	m_hWnd = CreateWindowEx(dwExStyle,
							CBASE_WINDOW_CLASS,
							NULL,dwStyle,
							x,y,nWidth,nHeight,
							hwndParent,
							hmenu,hinst,(VOID *)this);

	m_hInst = hinst;
	m_hWOwner = hwndParent;

	return m_hWnd;
}

BOOL CMsgWindow::SetFontSize(int iSize){
	if(m_hFont != NULL)DeleteObject(m_hFont);

	m_hFont = CreateFont(iSize, 0, 0, 0,
			FW_SEMIBOLD,
			FALSE, FALSE, FALSE, 
			SHIFTJIS_CHARSET , OUT_TT_PRECIS , 
			CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, 
			DEFAULT_PITCH , "lr SVbN");

	if(m_hFont != NULL)return TRUE;

	return FALSE;
}

BOOL CMsgWindow::DrawMassage(HDC hdc){
	HGDIOBJ hObj;
	int iMode;
	COLORREF col,bkCol;
	
	if(hdc == NULL) return FALSE;

	if(m_flagShow == TRUE){
		
		//F/tHgݒ肷
		hObj = SelectObject(hdc,m_hFont);
		iMode = SetBkMode(hdc,OPAQUE);	
		col = SetTextColor(hdc,m_StrColA);
		bkCol = SetBkColor(hdc,m_BackCol);

		//eLXg`悷
		TextOut(hdc,m_x-1	,m_y-1,m_str,strlen(m_str));
		TextOut(hdc,m_x+1	,m_y+1	,m_str,strlen(m_str));
		SetTextColor(hdc,m_StrCol);
		TextOut(hdc,m_x,m_y,m_str,strlen(m_str));

		//F/tHg̐ݒɖ߂
		SelectObject(hdc,hObj);
		SetBkMode(hdc,iMode);	
		SetTextColor(hdc,col);
		SetBkColor(hdc,bkCol);
	}

	return TRUE;
}

int CMsgWindow::DrawMassage(void){

	HDC hdc;

	if(m_hWnd == NULL)return FALSE;

	hdc = GetDC(m_hWnd);
	if(hdc == NULL)return FALSE;
	
	DrawMassage(hdc);

	ReleaseDC(m_hWnd,hdc);

	return TRUE;
}

int CMsgWindow::EraseMassage(void){

	SIZE sz;
	RECT rc;
	HGDIOBJ hObj;
	HDC hdc;

	if(m_hWnd == NULL)return FALSE;

	hdc = GetDC(m_hWnd);
	if(hdc == NULL) return TRUE;

	hObj = SelectObject(hdc,m_hFont);
	if(GetTextExtentPoint32(hdc,m_str,strlen(m_str),&sz) != FALSE){
		rc.left = 0;
		rc.right = sz.cx;
		rc.top = 0;
		rc.bottom = sz.cy;
		InvalidateRect(m_hWnd,&rc,TRUE);
		UpdateWindow(m_hWnd);
	}
	SelectObject(hdc,hObj);

	ReleaseDC(m_hWnd,hdc);

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//ݒ肳ꂽ̕\/\؂ւ
//:mode -> TRUE : \AFALSE : \Ȃ
//߂l:Ȃ
void CMsgWindow::ShowString(int mode){

	if(m_hWnd == NULL)return;

	if(mode == TRUE){
		//tOύX
		m_flagShow = TRUE;

		//EChEőOʂɈړ
		SetForegroundWindow(m_hWnd);

		//bZ[W`悷
		InvalidateRect(m_hWnd,NULL,TRUE);
		UpdateWindow(m_hWnd);
	}
	else{
		//tOݒ肷
		m_flagShow = FALSE;
		EraseMassage();
	}
}

//////////////////////////////////////////////////////////////////////////////
//EChE\
//:iOffTime -> \(~b)(0ȉw肵ꍇ́AȂ)
//߂l:Ȃ
void CMsgWindow::Show(int iOffTime){
	
	//Window\
	ShowWindow(m_hWnd,SW_SHOW);
	SetWindowPos(m_hWnd,HWND_TOP,0,0,0,0,SWP_NOMOVE|SWP_NOSIZE);

	UpdateWindow(m_hWnd);

	if(iOffTime > 0){
		SetTimer(m_hWnd,TIMER_ID_STRING_OFF,iOffTime,NULL);
	}
}

//////////////////////////////////////////////////////////////////////////////
//EChE\ɂ
//:Ȃ
//߂l:Ȃ
void CMsgWindow::Hide(void){
	//Window\ɂ
	ShowWindow(m_hWnd,SW_HIDE);
}

//////////////////////////////////////////////////////////////////////////////
//wiFݒ肷
//:col -> wi̐F
//߂l:TRUE -> AFALSE -> s
BOOL CMsgWindow::SetBackColor(COLORREF col){
	if(m_hBrush != NULL)DeleteObject(m_hBrush);
	
	m_hBrush = CreateSolidBrush(col);
	m_BackCol = col;

	return TRUE;
}
//////////////////////////////////////////////////////////////////////////////
//ݒ肷
//:col -> ̐Fݒ肷(A`VFO̐Fcol / 2Őݒ肳)
//߂l:TRUE -> AFALSE -> s
BOOL CMsgWindow::SetStringColor(COLORREF col){
	BYTE bR,bG,bB;
	
	m_StrCol = col;

	bR = GetRValue(col);
	bG = GetGValue(col);
	bB = GetBValue(col);
	
	m_StrColA = RGB(bR/2, bG/2, bB/2);

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//̍擾
//:Ȃ
//߂l:`悷镶̍̍ől
BOOL CMsgWindow::GetStringHeight(int *piHeight){
	HDC hdc;
	SIZE stSize;
	HGDIOBJ hOldObj;

	if(m_hWnd == NULL)return FALSE;

	//̕`TCY擾
	hdc = GetDC(m_hWnd);
	if(hdc == NULL) return FALSE;

	hOldObj = SelectObject(hdc,m_hFont);

	GetTextExtentPoint32(hdc,"T",1,&stSize);
	*piHeight = stSize.cy;

	SelectObject(hdc,hOldObj);
	ReleaseDC(m_hWnd,hdc);

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//^C}[nh
void CMsgWindow::OnTimerStringOff(void){
	KillTimer(m_hWnd,TIMER_ID_STRING_OFF);
	Hide();
}

//////////////////////////////////////////////////////////////////////////////
//bZ[Wnh
int CMsgWindow::OnWmCreate(HWND hW,WPARAM wP,LPARAM lP){
	
	//wi`puV쐬
	if(m_hBrush == NULL)m_hBrush = CreateSolidBrush(OVERLAY_COLOR);

	//tHg쐬
	SetFontSize(28);

	return 0;
}

int CMsgWindow::OnWmTimer(HWND hW,WPARAM wP,LPARAM lP){
	switch(wP){
	case TIMER_ID_STRING_OFF:
		OnTimerStringOff();
		break;
	}

	return 0;
}

int CMsgWindow::OnWmPaint(HWND hW,WPARAM wP,LPARAM lP){

	HDC hdc;
	PAINTSTRUCT ps;
	RECT rc;

	hdc = BeginPaint(hW,&ps);

	if(hdc != NULL){
		//NCAg̈擾
		GetClientRect(hW,&rc);

		//wihԂ
		FillRect(hdc,&rc,m_hBrush);

		//`悷
		DrawMassage(hdc);
	}

	EndPaint(hW,&ps);

	return TRUE;
}

/*int	CMsgWindow::OnWmActivate(HWND hW,WPARAM wP,LPARAM lP){
	DWORD fActive = LOWORD(wP);           // activation flag 
	DWORD fMinimized = (BOOL) HIWORD(wP); // minimized flag 
	HWND hwndPrevious = (HWND) lP;       // window handle 
 
	ErrMsg("[inf]CMsgWindow::OnWmActivate fActive=%d , fMinimized=%d , hwndPrevious=%08x",fActive,fMinimized,hwndPrevious);
	if(IsWindowVisible(m_hWnd) == TRUE){
		if(fActive == WA_INACTIVE){
			SetForegroundWindow(m_hWnd);
		}
	}

	return 0;
}*/

int CMsgWindow::OnWmClose(HWND hW,WPARAM wP,LPARAM lP){

	//^C}[j
	KillTimer(hW,TIMER_ID_STRING_OFF);

	//EChEj
	DestroyWindow(hW);

	return 0;
}

LRESULT CMsgWindow::WndProck(HWND hW, UINT uMsg, WPARAM wParam, LPARAM lParam){
	switch (uMsg){
/*		case WM_ACTIVATE:
			OnWmActivate(hW,wParam,lParam);
			break;*/
		case WM_PAINT:
			OnWmPaint(hW,wParam,lParam);
			break;
		case WM_DESTROY:
			m_hWnd = NULL;
			break;
		case WM_CLOSE:
			OnWmClose(hW,wParam,lParam);
			break;
		case WM_CREATE:
			OnWmCreate(hW,wParam,lParam);
			break;
		case WM_TIMER:
			OnWmTimer(hW,wParam,lParam);
			break;

		default:
			return DefWindowProc(hW,uMsg,wParam,lParam);
		break;
	}

	return 0;
}
