#include <windows.h>
#include <stdio.h>
#include <io.h>

#include "CSkinPlayer.h"
#include "..\util\StrUtil.h"

//XLt@C̃R}h
#define SKIN_CMD_NUM 6
static char *szSkinCmd [] = {
	"Button",
	"Volume",
	"PlayerStat",
	"PlayInfo",
	"PlayClock",
	"MainBack",
};

//{^^Cv̒`
static char *szSkinBtnType [] = {
	"STOP",
	"REC",
	"VolumeUP",
	"VolumeDown",
	"iEPG",
	"PlayerWindow",
	"Mute",
	"MuteOff",
	"ChannelUP",
	"ChannelDown",
	"SnapShot",
	"AppExit",
	"Close",
	"Config",
	"Ch01",
	"Ch02",
	"Ch03",
	"Ch04",
	"Ch05",
	"Ch06",
	"Ch07",
	"Ch08",
	"Ch09",
	"Ch10",
	"Ch11",
	"Ch12",
};

//////////////////////////////////////////////////////////////////////////////
//{[o[J
//:*pBtnInfo -> {^ւ̃|C^
//߂lȂ
void SafeReleaseVolumeInfo(PTDIGI_SKIN_VOLUMEBAR *pBtnInfo){
	if(pBtnInfo->pszBmpDefault != NULL)delete [] pBtnInfo->pszBmpDefault;
	if(pBtnInfo->pszBmpSelect != NULL)delete [] pBtnInfo->pszBmpSelect;
	if(pBtnInfo->pszBmpMute != NULL)delete [] pBtnInfo->pszBmpMute;
	ZeroMemory(pBtnInfo,sizeof(PTDIGI_SKIN_VOLUMEBAR));
}

//////////////////////////////////////////////////////////////////////////////
//vC[J
//:*pBtnInfo -> {^ւ̃|C^
//߂lȂ
void SafeReleasePlayerStatInfo(PTDIGI_SKIN_PLAYER_STATUS *pBtnInfo){
	if(pBtnInfo->pszBmpTVWatch != NULL)delete [] pBtnInfo->pszBmpTVWatch;
	if(pBtnInfo->pszBmpRecord != NULL)delete [] pBtnInfo->pszBmpRecord;

	ZeroMemory(pBtnInfo,sizeof(PTDIGI_SKIN_PLAYER_STATUS));
}

/////////////////////////////////////////////////////////
CSkinPlayer::CSkinPlayer(){
	m_iBtnNum = 0;			//{^
	m_pBtnInfo = NULL;		//{^

	ZeroMemory(&m_VolumeBarInfo,sizeof(PTDIGI_SKIN_VOLUMEBAR));	//{[
	ZeroMemory(&m_pPlayerStat,	sizeof(PTDIGI_SKIN_PLAYER_STATUS));
	ZeroMemory(&m_pPlayerInfo,	sizeof(PTDIGI_SKIN_PLAYER_INFO));
	ZeroMemory(&m_pClock,		sizeof(PTDIGI_SKIN_PLAYER_CLOCK));
	ZeroMemory(&m_MainWnd,		sizeof(PTDIGI_SKIN_MAINWND));

	m_nWidth = 0;						//XL̕(XL^CvɂĂ͏0)
	m_nHeight = 46;						//XL̍(XL^CvɂĂ͏0)
}

CSkinPlayer::~CSkinPlayer(){
	ClearSkinData();
}

BOOL CSkinPlayer::GetBtnInfo(int num,PTDIGI_SKIN_BUTTON *pInfo){
	if(num >= 0 && num <= m_iBtnNum){
		CopyMemory(pInfo,&m_pBtnInfo[num],sizeof(PTDIGI_SKIN_BUTTON));
		return TRUE;
	}
	return FALSE;
}

BOOL CSkinPlayer::GetVolumeInfo(PTDIGI_SKIN_VOLUMEBAR *pInfo){
	CopyMemory(pInfo,&m_VolumeBarInfo,sizeof(PTDIGI_SKIN_VOLUMEBAR));
	return TRUE;
}

BOOL CSkinPlayer::GetPlayerStatInfo(PTDIGI_SKIN_PLAYER_STATUS *pInfo){
	CopyMemory(pInfo,&m_pPlayerStat,sizeof(PTDIGI_SKIN_PLAYER_STATUS));
	return TRUE;
}

BOOL CSkinPlayer::GetPlayerInfo(PTDIGI_SKIN_PLAYER_INFO *pInfo){
	CopyMemory(pInfo,&m_pPlayerInfo,sizeof(PTDIGI_SKIN_PLAYER_INFO));
	return TRUE;
}

BOOL CSkinPlayer::GetClockInfo(PTDIGI_SKIN_PLAYER_CLOCK *pInfo){
	CopyMemory(pInfo,&m_pClock,sizeof(PTDIGI_SKIN_PLAYER_CLOCK));
	return TRUE;
}

BOOL CSkinPlayer::GetMainWndInfo(PTDIGI_SKIN_MAINWND *pInfo){
	CopyMemory(pInfo,&m_MainWnd,sizeof(PTDIGI_SKIN_MAINWND));
	return TRUE;
}


//////////////////////////////////////////////////////////////////////////////
//ێĂXLJ
//:Ȃ
//߂l:Ȃ
void CSkinPlayer::ClearSkinData(void){
	
	int i;
	//{^
	if(m_pBtnInfo != NULL){
		for(i=0;i<m_iBtnNum;++i){
			SafeReleaseBtnInfo(&m_pBtnInfo[i]);
		}
		delete [] m_pBtnInfo;
		m_pBtnInfo = NULL;
		m_iBtnNum = 0;
	}

	//ftHg̍Aݒ肷
	m_nWidth = 0;						//XL̕(XL^CvɂĂ͏0)
	m_nHeight = 46;						//XL̍(XL^CvɂĂ͏0)

	//{[J
	SafeReleaseVolumeInfo(&m_VolumeBarInfo);

	//ԕ\(vC[)̏J
	SafeReleasePlayerStatInfo(&m_pPlayerStat);

	//vC[̏\J
	if(m_pPlayerInfo.stFont.pszFontName != NULL){
		delete [] m_pPlayerInfo.stFont.pszFontName;
		m_pPlayerInfo.stFont.pszFontName = NULL;
	}
	ZeroMemory(&m_pPlayerInfo,sizeof(PTDIGI_SKIN_PLAYER_INFO));

	//vC[(v)
	for(i=0;i<10;++i){
		if(m_pClock.pszBmpNum[i] != NULL)delete [] m_pClock.pszBmpNum[i];
	}
	if(m_pClock.pszBmpCoron != NULL)delete [] m_pClock.pszBmpCoron;
	ZeroMemory(&m_pClock,sizeof(PTDIGI_SKIN_PLAYER_CLOCK));

	//CEChEJ
	if(m_MainWnd.pszBmpBack != NULL){
		delete [] m_MainWnd.pszBmpBack;
		m_MainWnd.pszBmpBack = NULL;
	}
	ZeroMemory(&m_MainWnd,sizeof(PTDIGI_SKIN_MAINWND));

}

//////////////////////////////////////////////////////////////////////////////
//񂩂R}h擾
//:R}h܂ޕ
//߂l:R}hԍ
int CSkinPlayer::CheckCommand(char *pBuf){
	int i;
	
	if(pBuf == NULL)return -1;
	if(pBuf[0] == '#') return -1;//Rg̏ꍇ͖ɂ

	//R}hmF
	for(i=0;i<SKIN_CMD_NUM;++i)
		if(iStrCmpPosition(pBuf,szSkinCmd[i]) != -1)
			return i;

	return -1;
}

//////////////////////////////////////////////////////////////////////////////
//񂩂{^̋@\ԍ擾
//:
//߂l:@\ԍ
int CSkinPlayer::CheckBtnType(char *pBuf){
	int i;
	
	if(pBuf == NULL)return -1;

	//R}hmF
	for(i=0;i<PTDIGI_Func_Last;++i)
		if(_stricmp(pBuf,szSkinBtnType[i]) == 0)return i;

	return -1;
}

//////////////////////////////////////////////////////////////////////////////
//{^f[^ǂݍݗp֐
//:pBuf -> ܂ރobt@
//     pBtnInfo -> {^󂯎|C^
//߂l:TRUE 
//       FALSE s
BOOL CSkinPlayer::GetBtnInfo(char *pBuf,PTDIGI_SKIN_BUTTON *pBtnInfo){
	int i,nBufLength;
	char *pChkBuf=NULL;
	int cbChkBuf;

	char *pBtnType=NULL;

	int nCol[4];

	if(pBuf == NULL)return FALSE;
	if(pBtnInfo == NULL)return FALSE;

	//obt@̃TCY擾
	nBufLength = strlen(pBuf);

	for(i=0;i<nBufLength;++i){
		//s܂ł̃TCY擾
		cbChkBuf = strlenex(&pBuf[i]);
		if(pChkBuf != NULL){
			delete [] pChkBuf;
			pChkBuf = NULL;
		}
		
		//s܂ł̃obt@擾
		pChkBuf = new char [cbChkBuf + 1];
		CopyMemory(pChkBuf,&pBuf[i],cbChkBuf);
		pChkBuf[cbChkBuf] = '\0';

		//\ʒu擾
		if(iStrCmpPosition(pChkBuf,"pos") != -1){
			GetNumber(pChkBuf,2,&nCol[0]);
			pBtnInfo->nX = nCol[0];
			pBtnInfo->nY = nCol[1];

		}

		//rbg}bvW擾
		if(iStrCmpPosition(pChkBuf,"bmp_normal") != -1){
			GetString2(pChkBuf,&pBtnInfo->pszBmpDefault);
		}

		//rbg}bv(I)擾
		if(iStrCmpPosition(pChkBuf,"bmp_over") != -1){
			GetString2(pChkBuf,&pBtnInfo->pszBmpSelect);
		}

		//rbg}bv()擾
		if(iStrCmpPosition(pChkBuf,"bmp_disable") != -1){
			GetString2(pChkBuf,&pBtnInfo->pszBmpDeisable);
		}
		
		//rbg}bv()擾
		if(iStrCmpPosition(pChkBuf,"bmp_push") != -1){
			GetString2(pChkBuf,&pBtnInfo->pszBmpPush);
		}
		
		//{^̋@\擾
		if(iStrCmpPosition(pChkBuf,"func") != -1){
			GetString2(pChkBuf,&pBtnType);
			pBtnInfo->nFunction = CheckBtnType(pBtnType);
			delete [] pBtnType;
			pBtnType = NULL;
		}

		//JEgAbv
		i += cbChkBuf;
	}

	if(pChkBuf != NULL){
		delete [] pChkBuf;
		pChkBuf = NULL;
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//V[No[ ǂݍݗp֐
//:pBuf -> ܂ރobt@
//     pVolInfo -> 󂯎|C^
//߂l:TRUE 
//       FALSE s
BOOL CSkinPlayer::GetVolumeInfo(char *pBuf,PTDIGI_SKIN_VOLUMEBAR *pVolInfo){
	int i,nBufLength;
	char *pChkBuf=NULL;
	int cbChkBuf;

	int nCol[4];

	if(pBuf == NULL)return FALSE;
	if(pVolInfo == NULL)return FALSE;

	//obt@̃TCY擾
	nBufLength = strlen(pBuf);

	for(i=0;i<nBufLength;++i){
		//s܂ł̃TCY擾
		cbChkBuf = strlenex(&pBuf[i]);
		if(pChkBuf != NULL){
			delete [] pChkBuf;
			pChkBuf = NULL;
		}
		
		//s܂ł̃obt@擾
		pChkBuf = new char [cbChkBuf + 1];
		CopyMemory(pChkBuf,&pBuf[i],cbChkBuf);
		pChkBuf[cbChkBuf] = '\0';

		//\ʒu擾
		if(iStrCmpPosition(pChkBuf,"pos") != -1){
			GetNumber(pChkBuf,2,&nCol[0]);
			pVolInfo->nX = nCol[0];
			pVolInfo->nY = nCol[1];

		}

		//rbg}bvW擾
		if(iStrCmpPosition(pChkBuf,"bmp_normal") != -1){
			GetString2(pChkBuf,&pVolInfo->pszBmpDefault);
		}

		//rbg}bv(I)擾
		if(iStrCmpPosition(pChkBuf,"bmp_over") != -1){
			GetString2(pChkBuf,&pVolInfo->pszBmpSelect);
		}

		//rbg}bv(I)擾
		if(iStrCmpPosition(pChkBuf,"bmp_mute") != -1){
			GetString2(pChkBuf,&pVolInfo->pszBmpMute);
		}

		//JEgAbv
		i += cbChkBuf;
	}

	if(pChkBuf != NULL){
		delete [] pChkBuf;
		pChkBuf = NULL;
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//uPlatyeȑԂ\v ǂݍݗp֐
//:pBuf -> ܂ރobt@
//     pLsInfo -> 󂯎|C^
//߂l:TRUE 
//       FALSE s
BOOL CSkinPlayer::GetPlayerStatInfo(char *pBuf,PTDIGI_SKIN_PLAYER_STATUS *pLsInfo){
	int i,nBufLength;
	char *pChkBuf=NULL;
	int cbChkBuf;

	int nCol[4];

	if(pBuf == NULL)return FALSE;
	if(pLsInfo == NULL)return FALSE;

	//obt@̃TCY擾
	nBufLength = strlen(pBuf);

	for(i=0;i<nBufLength;++i){
		//s܂ł̃TCY擾
		cbChkBuf = strlenex(&pBuf[i]);
		if(pChkBuf != NULL){
			delete [] pChkBuf;
			pChkBuf = NULL;
		}
		
		//s܂ł̃obt@擾
		pChkBuf = new char [cbChkBuf + 1];
		CopyMemory(pChkBuf,&pBuf[i],cbChkBuf);
		pChkBuf[cbChkBuf] = '\0';

		//\ʒu擾
		if(iStrCmpPosition(pChkBuf,"pos") != -1){
			GetNumber(pChkBuf,2,&nCol[0]);
			pLsInfo->nX = nCol[0];
			pLsInfo->nY = nCol[1];

		}

		//rbg}bvFĐ擾

		//rbg}bvFer(Xg[Đ)
		if(iStrCmpPosition(pChkBuf,"bmp_tvwatch") != -1){
			GetString2(pChkBuf,&pLsInfo->pszBmpTVWatch);
		}

		//rbg}bvF^撆
		if(iStrCmpPosition(pChkBuf,"bmp_record") != -1){
			GetString2(pChkBuf,&pLsInfo->pszBmpRecord);
		}

		//JEgAbv
		i += cbChkBuf;
	}

	if(pChkBuf != NULL){
		delete [] pChkBuf;
		pChkBuf = NULL;
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//uPlatyer̎v\v ǂݍݗp֐
//:pBuf -> ܂ރobt@
//     pInfo -> 󂯎|C^
//߂l:TRUE 
//       FALSE s
BOOL CSkinPlayer::GetClockInfo(char *pBuf,PTDIGI_SKIN_PLAYER_CLOCK *pInfo){
	int i,nBufLength;
	char *pChkBuf=NULL;
	int cbChkBuf;

	int nCol[4];

	if(pBuf == NULL)return FALSE;
	if(pInfo == NULL)return FALSE;

	//obt@̃TCY擾
	nBufLength = strlen(pBuf);

	for(i=0;i<nBufLength;++i){
		//s܂ł̃TCY擾
		cbChkBuf = strlenex(&pBuf[i]);
		if(pChkBuf != NULL){
			delete [] pChkBuf;
			pChkBuf = NULL;
		}
		
		//s܂ł̃obt@擾
		pChkBuf = new char [cbChkBuf + 1];
		CopyMemory(pChkBuf,&pBuf[i],cbChkBuf);
		pChkBuf[cbChkBuf] = '\0';

		//\ʒu擾
		if(iStrCmpPosition(pChkBuf,"pos") != -1){
			GetNumber(pChkBuf,2,&nCol[0]);
			pInfo->nX = nCol[0];
			pInfo->nY = nCol[1];

		}

		//rbg}bvF
		if(iStrCmpPosition(pChkBuf,"bmp_1") != -1){
			GetString2(pChkBuf,&pInfo->pszBmpNum[1]);
		}

		//rbg}bvF
		if(iStrCmpPosition(pChkBuf,"bmp_2") != -1){
			GetString2(pChkBuf,&pInfo->pszBmpNum[2]);
		}

		//rbg}bvF
		if(iStrCmpPosition(pChkBuf,"bmp_3") != -1){
			GetString2(pChkBuf,&pInfo->pszBmpNum[3]);
		}
		//rbg}bvF
		if(iStrCmpPosition(pChkBuf,"bmp_4") != -1){
			GetString2(pChkBuf,&pInfo->pszBmpNum[4]);
		}
		//rbg}bvF
		if(iStrCmpPosition(pChkBuf,"bmp_5") != -1){
			GetString2(pChkBuf,&pInfo->pszBmpNum[5]);
		}

		//rbg}bvF
		if(iStrCmpPosition(pChkBuf,"bmp_6") != -1){
			GetString2(pChkBuf,&pInfo->pszBmpNum[6]);
		}

		//rbg}bvF
		if(iStrCmpPosition(pChkBuf,"bmp_7") != -1){
			GetString2(pChkBuf,&pInfo->pszBmpNum[7]);
		}

		//rbg}bvF
		if(iStrCmpPosition(pChkBuf,"bmp_8") != -1){
			GetString2(pChkBuf,&pInfo->pszBmpNum[8]);
		}

		//rbg}bvF
		if(iStrCmpPosition(pChkBuf,"bmp_9") != -1){
			GetString2(pChkBuf,&pInfo->pszBmpNum[9]);
		}

		//rbg}bvF
		if(iStrCmpPosition(pChkBuf,"bmp_0") != -1){
			GetString2(pChkBuf,&pInfo->pszBmpNum[0]);
		}

		//rbg}bvF
		if(iStrCmpPosition(pChkBuf,"bmp_k") != -1){
			GetString2(pChkBuf,&pInfo->pszBmpCoron);
		}

		//JEgAbv
		i += cbChkBuf;
	}

	if(pChkBuf != NULL){
		delete [] pChkBuf;
		pChkBuf = NULL;
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//uCEChEv ǂݍݗp֐
//:pBuf -> ܂ރobt@
//     pInfo -> 󂯎|C^
//߂l:TRUE 
//       FALSE s
BOOL CSkinPlayer::GetMainWndInfo(char *pBuf,PTDIGI_SKIN_MAINWND *pInfo){
	int i,nBufLength;
	char *pChkBuf=NULL;
	int cbChkBuf;

	int nCol[4];

	if(pBuf == NULL)return FALSE;
	if(pInfo == NULL)return FALSE;

	//obt@̃TCY擾
	nBufLength = strlen(pBuf);

	for(i=0;i<nBufLength;++i){
		//s܂ł̃TCY擾
		cbChkBuf = strlenex(&pBuf[i]);
		if(pChkBuf != NULL){
			delete [] pChkBuf;
			pChkBuf = NULL;
		}
		
		//s܂ł̃obt@擾
		pChkBuf = new char [cbChkBuf + 1];
		CopyMemory(pChkBuf,&pBuf[i],cbChkBuf);
		pChkBuf[cbChkBuf] = '\0';

		//rbg}bvF
		if(iStrCmpPosition(pChkBuf,"bmp_Back") != -1){
			GetString2(pChkBuf,&pInfo->pszBmpBack);
		}

		//\ʒu擾
		if(iStrCmpPosition(pChkBuf,"size") != -1){
			GetNumber(pChkBuf,2,&nCol[0]);
			pInfo->nWidth = nCol[0];
			pInfo->nHeight = nCol[1];

		}

		//JEgAbv
		i += cbChkBuf;
	}

	if(pChkBuf != NULL){
		delete [] pChkBuf;
		pChkBuf = NULL;
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//XLf[^ɒ`Ă{^擾
//:pBuf -> f[^ւ̃|C^
//     cbBuf -> f[^TCY
//߂l:{^̐
int CSkinPlayer::GetBtnNumInSkin(char *pBuf,int cbBuf){
	int i,iBtnNum = 0;
	char *pChkBuf = NULL;
	int cbChkBuf;

	for(i = 0;i < cbBuf;++i){
		//s܂ł̃TCY擾
		cbChkBuf = strlenex(&pBuf[i]);
		if(pChkBuf != NULL){
			delete [] pChkBuf;
			pChkBuf = NULL;
		}
		
		//s܂ł̃obt@擾
		pChkBuf = new char [cbChkBuf + 1];
		CopyMemory(pChkBuf,&pBuf[i],cbChkBuf);
		pChkBuf[cbChkBuf] = '\0';
		
		//R}h̏s
		switch(CheckCommand(pChkBuf)){
		case 0://{^
			//{}ň͂ӏ΂
			i = i + GetConfigrationSet2(&pBuf[i],NULL);
			++iBtnNum;
			break;
		case -1://Rg̏ꍇ̏
			break;
		}

		//JE^グ
		i += cbChkBuf;

	}

	if(pChkBuf != NULL)delete [] pChkBuf;

	return iBtnNum;
}

//////////////////////////////////////////////////////////////////////////////
//XLf[^ǂݍ
//:pszFileName@XLt@C
//߂l: TRUE 
//        FALSE s
BOOL CSkinPlayer::ReadSkinData(char *pszFileName){
	FILE *fp;
	unsigned int uiFileSize,ui,cbChkBuf;
	char *pBuf=NULL,*pChkBuf=NULL;
	int iCmdNum;//XNvg̖ߔԍ
	int iBtnNum;//{^擾

	char *pDataBuf = NULL;
	int cbDataBuf;

	//XLf[^ǂݍ
	fp = fopen(pszFileName,"rb");
	if(fp == NULL)return FALSE;

	uiFileSize = _filelength(_fileno(fp));

	pBuf = new char [uiFileSize+1];
	pBuf[uiFileSize] = '\0';
	if(pBuf == NULL){
		fclose(fp);
		return FALSE;
	}
	fread(pBuf,sizeof(char),uiFileSize,fp);
	fclose(fp);

	//XLf[^
	ClearSkinData();

	//{^擾Aۑ邽߂̃mۂ
	m_iBtnNum = GetBtnNumInSkin(pBuf,uiFileSize);
	if(m_iBtnNum > 0){
		m_pBtnInfo = new PTDIGI_SKIN_BUTTON[m_iBtnNum];
		ZeroMemory(m_pBtnInfo,sizeof(PTDIGI_SKIN_BUTTON) * m_iBtnNum);
	}
	iBtnNum = 0;

	//擾
	for(ui = 0;ui < uiFileSize;++ui){
		//s܂ł̃TCY擾
		cbChkBuf = strlenex(&pBuf[ui]);
		if(pChkBuf != NULL){
			delete [] pChkBuf;
			pChkBuf = NULL;
		}
		
		//s܂ł̃obt@擾
		pChkBuf = new char [cbChkBuf + 1];
		CopyMemory(pChkBuf,&pBuf[ui],cbChkBuf);
		pChkBuf[cbChkBuf] = '\0';
		
		//R}h̏s
		iCmdNum = CheckCommand(pChkBuf);
		switch(iCmdNum){
		case -1://Rg̏ꍇ̏
			//ui = ui + strlen(pChkBuf);//cbChkBuf;
			break;
		case 0://{^
			if(iBtnNum < m_iBtnNum){
				cbDataBuf = GetConfigrationSet2(&pBuf[ui],&pDataBuf);
				if(cbDataBuf > 0){

					GetBtnInfo(pDataBuf,&m_pBtnInfo[iBtnNum]);
					++iBtnNum;

					delete [] pDataBuf;
					pDataBuf = NULL;
					cbChkBuf = cbDataBuf;
				}
			}
			break;
		case 1://{[o[
			cbDataBuf = GetConfigrationSet2(&pBuf[ui],&pDataBuf);
			if(cbDataBuf > 0){
				GetVolumeInfo(pDataBuf,&m_VolumeBarInfo);
				delete [] pDataBuf;
				pDataBuf = NULL;

				cbChkBuf = cbDataBuf;
			}
			break;
		case 2://Playeȑ\ʒu
			cbDataBuf = GetConfigrationSet2(&pBuf[ui],&pDataBuf);
			if(cbDataBuf > 0){

				GetPlayerStatInfo(pDataBuf,&m_pPlayerStat);

				delete [] pDataBuf;
				pDataBuf = NULL;

				cbChkBuf = cbDataBuf;
			}
			break;
		case 3://Player̍Đ\ʒu
			cbDataBuf = GetConfigrationSet2(&pBuf[ui],&pDataBuf);
			if(cbDataBuf > 0){

				GetFontParam(pDataBuf,&m_pPlayerInfo.rc,&m_pPlayerInfo.stFont);

				delete [] pDataBuf;
				pDataBuf = NULL;

				cbChkBuf = cbDataBuf;
			}
			break;
		case 4://Plater̎v
			cbDataBuf = GetConfigrationSet2(&pBuf[ui],&pDataBuf);
			if(cbDataBuf > 0){

				GetClockInfo(pDataBuf,&m_pClock);

				delete [] pDataBuf;
				pDataBuf = NULL;

				cbChkBuf = cbDataBuf;
			}
			break;
		case 5://CEChEwi̎擾
			cbDataBuf = GetConfigrationSet2(&pBuf[ui],&pDataBuf);
			if(cbDataBuf > 0){

				GetMainWndInfo(pDataBuf,&m_MainWnd);

				delete [] pDataBuf;
				pDataBuf = NULL;

				cbChkBuf = cbDataBuf;
			}
			break;

		}

		//JE^グ
		ui += cbChkBuf;
	}

	//Aݒ肷
	m_nWidth = m_MainWnd.nWidth;
	m_nHeight = m_MainWnd.nHeight;

	//gp
	if(pBuf != NULL)delete [] pBuf;
	if(pChkBuf != NULL)delete [] pChkBuf;
	
	return TRUE;
}
